Bug 1313828 - Review Request: open-nat - Library to allow port forwarding in NAT devices that support UPNP
Review Request: open-nat - Library to allow port forwarding in NAT devices th...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Antti Järvinen
Fedora Extras Quality Assurance
:
Depends On:
Blocks: openra
  Show dependency treegraph
 
Reported: 2016-03-02 07:19 EST by Raphael Groner
Modified: 2016-04-24 07:10 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-04-24 07:10:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
antti.jarvinen: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Raphael Groner 2016-03-02 07:19:53 EST
Spec URL: https://raphgro.fedorapeople.org/review/openra/open-nat.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/open-nat-2.0.11-1.20160128gita5c834d.fc23.src.rpm
Description: Library to allow port forwarding in NAT devices that support UPNP
Fedora Account System Username: raphgro

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=13200073

Note:
This project is a fork of Mono.NAT.
Comment 1 Upstream Release Monitoring 2016-03-02 07:22:19 EST
raphgro's scratch build of open-nat-2.0.11-1.20160128gita5c834d.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=13200073
Comment 2 Antti Järvinen 2016-04-16 16:54:00 EDT
Hello Raphael,

and thank you for submitting open-nat for review. I'm not in packagers group so I can't submit your package forward but I hope my comments are useful for someone who can. I have reviewed your package with automated tool, looking at code, and running tests. Please find my comments below, included in checklist. All "must items" should be easy to fix. Outside the checklist I have this kind of question: as interfacing an existing library (native linux, .so -library) from c# is possible, would it make sense to have a wrapper around miniupnpc library to bring its functionality into world of mono and c#? While open-nat looks like a sane library to me, it still presents duplicated functionality..?

Of rpmlint warnings I'd raise the "no documentation" thing -> some kind of manpage or README-file or something would be a nice thing, because this thing is a library. 

--
Antti Järvinen


-> review checklist follows
===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 9 files have
     unknown license. Detailed output of licensecheck in /tmp/1313828-open-
     nat/1313828-open-nat/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
 -> Otherwise ok, but instead of having %doc LICENSE it should be
    %license LICENSE
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/mono/open-nat
    -> something like
     %dir %{_monogacdir}/%{libname}
     in %files-secion might be in order
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/mono/open-nat
     -> see comment at previous item. 
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
 -> note, there is exclucive mono architectures but I think that is unavoidable
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 102400 bytes in 16 files.
[!]: Package complies to the Packaging Guidelines
 -> ok, but with issues mentioned here
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
 -> note, tried only test suite, no errors, real world host-application
    was not built during review. 
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
 -> note, check is not present. It seems like there is test suite present
    so having that included in spec would be nice. Anyway, this is
    "nice to have" feature. 
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: open-nat-2.0.11-1.20160128gita5c834d.fc25.x86_64.rpm
          open-nat-devel-2.0.11-1.20160128gita5c834d.fc25.x86_64.rpm
          open-nat-2.0.11-1.20160128gita5c834d.fc25.src.rpm
open-nat.x86_64: W: spelling-error %description -l en_US amoung -> among, amount
open-nat.x86_64: E: no-binary
open-nat.x86_64: W: only-non-binary-in-usr-lib
open-nat.x86_64: W: hidden-file-or-dir /usr/share/doc/open-nat/Open.Nat.Tests/obj/Debug/.NETFramework,Version=v4.5.AssemblyAttribute.cs
open-nat.x86_64: W: spurious-executable-perm /usr/share/doc/open-nat/Open.Nat.Tests/obj/Debug/Open.Nat.Tests.exe
open-nat.x86_64: W: spurious-executable-perm /usr/share/doc/open-nat/Open.Nat.Tests/bin/Debug/Open.Nat.Tests.exe
open-nat-devel.x86_64: W: only-non-binary-in-usr-lib
open-nat-devel.x86_64: W: no-documentation
open-nat.src: W: spelling-error %description -l en_US amoung -> among, amount
open-nat.src:59: E: hardcoded-library-path in %{buildroot}/usr/lib
3 packages and 0 specfiles checked; 2 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
open-nat.x86_64: W: spelling-error %description -l en_US amoung -> among, amount
open-nat.x86_64: E: no-binary
open-nat.x86_64: W: only-non-binary-in-usr-lib
open-nat.x86_64: W: spurious-executable-perm /usr/share/doc/open-nat/Open.Nat.Tests/obj/Debug/Open.Nat.Tests.exe
open-nat.x86_64: W: spurious-executable-perm /usr/share/doc/open-nat/Open.Nat.Tests/bin/Debug/Open.Nat.Tests.exe
open-nat.x86_64: W: hidden-file-or-dir /usr/share/doc/open-nat/Open.Nat.Tests/obj/Debug/.NETFramework,Version=v4.5.AssemblyAttribute.cs
open-nat-devel.x86_64: W: only-non-binary-in-usr-lib
open-nat-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 7 warnings.



Requires
--------
open-nat (rpmlib, GLIBC filtered):
    mono(System)
    mono(System.Core)
    mono(System.Xml)
    mono(mscorlib)

open-nat-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    open-nat(x86-64)
    pkgconfig(mono)



Provides
--------
open-nat:
    mono(Open.Nat)
    open-nat
    open-nat(x86-64)

open-nat-devel:
    open-nat-devel
    open-nat-devel(x86-64)
    pkgconfig(open-nat)



Source checksums
----------------
https://github.com/lontivero/Open.NAT/archive/a5c834dd1402c23d2385e57e38849e74261ef5c7.tar.gz#/open-nat-a5c834dd1402c23d2385e57e38849e74261ef5c7.tar.gz :
  CHECKSUM(SHA256) this package     : 878f9e3af9bb6c15296d75b0519740e6b003de0481e7d942d84824a1390dae8d
  CHECKSUM(SHA256) upstream package : 878f9e3af9bb6c15296d75b0519740e6b003de0481e7d942d84824a1390dae8d


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1313828
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 3 Raphael Groner 2016-04-19 13:56:53 EDT
Hello Antti,

thanks for your interest in this review.

Most of your questions have nothing to do with the package review, propably they should go to upstream.

> [-]: %check is present and all tests pass.

%check is not missing, please look into the spec file. The test suite is not of much use for an automatic test, cause it just prints some individual output.

Spec URL: https://raphgro.fedorapeople.org/review/openra/open-nat.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/open-nat-2.0.11-2.20160413gitf288f8d.fc23.src.rpm

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=13719455

* Tue Apr 19 2016 Raphael Groner <> - 2.0.11-2.20160128gita5c834d
- add license tag
- fix folders ownership
- bump to new github snapshot
- disable nuget
- improve execution of tests
Comment 4 Antti Järvinen 2016-04-20 16:35:34 EDT
All right, 

I see that the "must" items previously mentioned are done so I'm almost ok with this review. One new thing could be fixed still, namely the

open-nat.src:62: E: hardcoded-library-path in %{buildroot}/usr/lib

rpmlint error from source rpm, see 
https://fedoraproject.org/wiki/Common_Rpmlint_issues#hardcoded-library-path
for details. The other rpmlint error from binary rpm that is "no binary" you
most likely can't fix due to wrong binary format (non-ELF on ELF-system).

--
Antti
Comment 5 Raphael Groner 2016-04-20 17:09:35 EDT
> open-nat.src:62: E: hardcoded-library-path in %{buildroot}/usr/lib

That's a false positive.
https://fedoraproject.org/wiki/Packaging:Mono#gacutil_in_a_spec_file
https://fedoraproject.org/wiki/Packaging:Mono#rpmlint_and_mono_packages
Comment 6 Antti Järvinen 2016-04-22 14:22:49 EDT
All right then, all the "must" items are fulfilled. 

What we would need is some additional support for rpmlint about mono packages, obviously it does not serve us well. 

--
Antti Järvinen
Comment 7 Raphael Groner 2016-04-22 18:53:17 EDT
Thanks for the review!
Comment 8 Kevin Fenzi 2016-04-23 12:51:02 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/open-nat

Note You need to log in before you can comment on or make changes to this bug.